Subject: Re: bug#56215: Request for decluttering capability on mode-line keywords

From: Howard Melman <[email-masked]>
Date: Fri, 01 Jul 2022 12:38:34 -0400

Lars Ingebrigtsen <[email-masked]> writes:

> Phil Sainty <[email-masked]> writes:
>
>> You might find the GNU ELPA package delight.el to be suitable.
>> See https://www.emacswiki.org/emacs/DelightedModes for details.
>>
>> There are other options as well, including these (and maybe
>> more besides):
>>
>> https://emacs.stackexchange.com/a/72194/454
>>
>> Lars, I think this is a duplicate of bug#30978 ?
>
> Yes, sort of.  And the conclusion is that there's a bunch of these
> packages out there for a reason -- people have very different needs and
> expectations for the mode line, so different packages makes sense.  So
> adding something to the core here wouldn't be helpful, and I'm therefore
> closing this bug report.

As I tried to express in bug#30978, one of the reasons there
are packages to do this is that some modes hardcode their
lighter string and if they defined variables instead, like
many other modes do, users (and these package writers) would
have an easier time.  Now that most minor modes use
define-minor-mode there's an easy place to correct this.

I think there are now 3 people supporting this and the only
argument against was:

On the one hand, a `foo-mode-lighter' variable would make
things easy and regular.  On the other hand, it means
creating a new user option for each minor mode (i.e., a
defcustom), and it means having these in `minor-mode-alist',
which means one additional variable lookup (per minor mode)
when creating the mode line.

I still think that's a fine trade off.  I see ~70 modes in emacs
that use a hard-coded :lighter string and most are specific
to some major mode as opposed to being generally on in all
modes.

I wish you'd reconsider bug#30978.

Also, the elisp manual when discussing :lighter doesn't
mention using a symbol as a value or the customization that
provides to the user and I think it should.

-- 

Howard